VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Form1"
   ClientHeight    =   4725
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   13830
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4725
   ScaleWidth      =   13830
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command2 
      Caption         =   "Benchmark"
      Enabled         =   0   'False
      Height          =   735
      Left            =   6660
      TabIndex        =   5
      Top             =   2040
      Width           =   1815
   End
   Begin VB.PictureBox Picture2 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   3915
      Left            =   9360
      ScaleHeight     =   3915
      ScaleWidth      =   4155
      TabIndex        =   4
      Top             =   240
      Width           =   4155
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Build quadtree"
      Height          =   735
      Left            =   6660
      TabIndex        =   1
      Top             =   240
      Width           =   1815
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   4230
      Left            =   240
      ScaleHeight     =   280
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   420
      TabIndex        =   0
      Top             =   240
      Width           =   6330
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Computed neighbors"
      Height          =   195
      Left            =   12060
      TabIndex        =   7
      Top             =   4260
      Width           =   1455
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      Caption         =   "Time"
      Height          =   195
      Left            =   8880
      TabIndex        =   6
      Top             =   240
      Width           =   375
   End
   Begin VB.Label Label2 
      Height          =   195
      Left            =   6660
      TabIndex        =   3
      Top             =   1740
      Width           =   1815
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label1 
      Height          =   615
      Left            =   6660
      TabIndex        =   2
      Top             =   1080
      Width           =   1815
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()

Dim i As Long
Dim MaxLevel As Long
Dim NumNodes As Long

Call InitQT(QT1)

For i = 0 To NumPoints - 1
    Call AddPoint(Points(i), i, QT1)
Next

NumNodes = CurrentNode

Form1.Picture1.Cls
Call DrawPoints
Call DrawGrid

For i = 0 To CurrentNode
    If QT1(i).Level > MaxLevel Then MaxLevel = QT1(i).Level
Next

Form1.Label1 = "Points: " & NumPoints & vbNewLine & "Nodes: " & NumNodes & vbNewLine & "Maximum depth: " & MaxLevel

Form1.Command2.Enabled = True

End Sub

Private Sub Command2_Click()

Dim TimeEuclid() As Double
Dim TimeQT() As Double
Dim i As Long
Dim j As Long
Dim k As Long
Dim BenchPoint As Point
Dim MaxX As Long
Dim MaxY As Long
Dim ThisEuclid As Double
Dim xTimer As New xTimer
Dim ArrPtr As Long
Dim ScaleLim As Long

ReDim TimeEuclid(0 To 800) As Double
ReDim TimeQT(0 To 800) As Double

MaxX = Form1.Picture1.ScaleWidth
MaxY = Form1.Picture1.ScaleHeight

xTimer.Kalibrieren
xTimer.Start
For i = 0 To 800
    BenchPoint.X = Rnd * MaxX
    BenchPoint.Y = Rnd * MaxY
    
    For j = 0 To NumPoints - 1
        MinEuclid = &H7FFFFFFF
        ThisEuclid = Euclid(BenchPoint, Points(j))
        If ThisEuclid < MinEuclid Then
            MinEuclid = ThisEuclid
        End If
    Next
Next
xTimer.Halt
ScaleLim = 2 * Int(xTimer.RunTime)

Form1.Picture2.Cls

Form1.Picture2.ScaleMode = vbPixels

Form1.Picture2.DrawStyle = vbDot
Form1.Picture2.Line (Form1.Picture2.ScaleWidth * 0.25, 0)-(Form1.Picture2.ScaleWidth * 0.25, 800), &H8000000F
Form1.Picture2.Line (Form1.Picture2.ScaleWidth * 0.5, 0)-(Form1.Picture2.ScaleWidth * 0.5, 800), &H8000000F
Form1.Picture2.Line (Form1.Picture2.ScaleWidth * 0.75, 0)-(Form1.Picture2.ScaleWidth * 0.75, 800), &H8000000F
Form1.Picture2.Line (0, Form1.Picture2.ScaleHeight * 0.25)-(800, Form1.Picture2.ScaleHeight * 0.25), &H8000000F
Form1.Picture2.Line (0, Form1.Picture2.ScaleHeight * 0.5)-(800, Form1.Picture2.ScaleHeight * 0.5), &H8000000F
Form1.Picture2.Line (0, Form1.Picture2.ScaleHeight * 0.75)-(800, Form1.Picture2.ScaleHeight * 0.75), &H8000000F
Form1.Picture2.DrawStyle = vbSolid

Form1.Picture2.Line (10, 10)-(50, 10), vbBlue
Form1.Picture2.CurrentX = 60
Form1.Picture2.CurrentY = 5
Form1.Picture2.Print "Simple euclidean"
Form1.Picture2.Line (10, 30)-(50, 30), vbRed
Form1.Picture2.CurrentX = 60
Form1.Picture2.CurrentY = 25
Form1.Picture2.Print "Quadtree"

Form1.Picture2.Scale (0, ScaleLim)-(800, 0)

Form1.MousePointer = vbHourglass

For k = 0 To 800
    xTimer.Kalibrieren
    xTimer.Start
    For i = (800 - k) To 800
        BenchPoint.X = Rnd * MaxX
        BenchPoint.Y = Rnd * MaxY

        For j = 0 To NumPoints - 1
            MinEuclid = &H7FFFFFFF
            ThisEuclid = Euclid(BenchPoint, Points(j))
            If ThisEuclid < MinEuclid Then
                MinEuclid = ThisEuclid
            End If
        Next
    Next
    xTimer.Halt
    TimeEuclid(k) = xTimer.RunTime
    If k > 0 Then Form1.Picture2.Line (k - 1, TimeEuclid(k - 1))-(k, TimeEuclid(k)), vbBlue
    Form1.Picture2.Refresh
Next

For k = 0 To 800
    xTimer.Kalibrieren
    xTimer.Start
    For i = (800 - k) To 800
        BenchPoint.X = Rnd * MaxX
        BenchPoint.Y = Rnd * MaxY

        Call FindClosest(BenchPoint, QT1)
    Next
    xTimer.Halt
    TimeEuclid(k) = xTimer.RunTime
    If k > 0 Then Form1.Picture2.Line (k - 1, TimeEuclid(k - 1))-(k, TimeEuclid(k)), vbRed
    Form1.Picture2.Refresh
Next

Form1.MousePointer = vbDefault

End Sub

Private Sub Form_Load()
    
Dim i As Long

NumPoints = 500

ReDim Points(0 To NumPoints - 1) As Point

Randomize Timer

For i = 0 To NumPoints - 1
    Points(i).X = Rnd * Form1.Picture1.ScaleWidth
    Points(i).Y = Rnd * Form1.Picture1.ScaleHeight
Next

Form1.Show
Call DrawPoints

End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim MyPoint As Point

If CurrentNode = 0 Then Exit Sub 'QuadTree not yet initialized.

MyPoint.X = X
MyPoint.Y = Y

Call FindClosest(MyPoint, QT1)

Form1.Picture1.Cls
Call DrawPoints
Call DrawGrid
Form1.Picture1.Line (MyPoint.X, MyPoint.Y)-(Points(FoundPoint).X, Points(FoundPoint).Y), vbRed

Form1.Label2 = "Euclids: " & EuclidsComputed

End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim i As Long
Dim MyPoint As Point
Dim Closest As Long
Dim MaxLevel As Long

If CurrentNode = 0 Then Exit Sub 'QuadTree not yet initialized.

MyPoint.X = X
MyPoint.Y = Y

NumPoints = NumPoints + 1
ReDim Preserve Points(0 To NumPoints - 1) As Point

Points(NumPoints - 1) = MyPoint

Call InitQT(QT1)

For i = 0 To NumPoints - 1
    Call AddPoint(Points(i), i, QT1)
Next

Call DrawGrid

For i = 0 To CurrentNode
    If QT1(i).Level > MaxLevel Then MaxLevel = QT1(i).Level
Next

Form1.Label1 = "Points: " & NumPoints & vbNewLine & "Nodes: " & CurrentNode & vbNewLine & "Maximum depth: " & MaxLevel

End Sub
