VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "xTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type LARGE_INTEGER
    Lo As Long
    Hi As Long
End Type

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As LARGE_INTEGER) As Long

Dim dblKalibrieren As Double
Dim udtStart As LARGE_INTEGER
Dim udtEnde As LARGE_INTEGER
Dim udtFreq As LARGE_INTEGER

Public Sub Kalibrieren()

Call QueryPerformanceCounter(udtStart)
Call QueryPerformanceCounter(udtEnde)

dblKalibrieren = (D(udtEnde) - D(udtStart)) / D(udtFreq) * 1000
    
End Sub

Private Sub Class_Initialize()

Call QueryPerformanceFrequency(udtFreq)
    
End Sub

Public Sub Halt()

Call QueryPerformanceCounter(udtEnde)
    
End Sub

Public Sub Start()

Call QueryPerformanceCounter(udtStart)
    
End Sub

Public Property Get RunTime() As Double

RunTime = (D(udtEnde) - D(udtStart)) / D(udtFreq) * 1000 - dblKalibrieren
    
End Property

Private Function D(udtX As LARGE_INTEGER) As Double

Dim dblHigh As Double
Dim dblLow As Double

dblLow = udtX.Lo
dblHigh = udtX.Hi

If dblLow < 0 Then
    dblLow = 4294967296# + dblLow + 1
End If

If dblHigh < 0 Then
    dblHigh = 4294967296# + dblHigh + 1
End If

D = dblLow + dblHigh * 4294967296#
    
End Function


